/*
 * DataBuffer.cpp
 *
 *  Created on: 1 Mar 2010
 *      Author: mat
 */

#include "DataBuffer.h"
#include "SDL/SDL.h"
#include "SDL/SDL_thread.h"
#include "SDL/SDL_mutex.h"

#define SERVER_MODE 0
#define CLIENT_MODE 1

/*
bool DataBuffer::quit = false;
TCPsocket DataBuffer::sd = NULL;
TCPsocket DataBuffer::csd = NULL;
bool DataBuffer::connected = false;
bool DataBuffer::connectedToClient = false;
bool DataBuffer::thread_running = false;
int DataBuffer::gameType = SERVER_MODE;
*/

//SDL_mutex* DataBuffer::datalock = NULL;
//int DataBuffer::max_frame_store = 1;
//DataBuffer::NetData* DataBuffer::arLemInData;//array of n frame changes
//DataBuffer::NetData* DataBuffer::arTempLemInData;//array of n frame changes
//DataBuffer::NetData* DataBuffer::arLemOutData;//array of n frame changes

DataBuffer::DataBuffer() {
	printf("creating new instance of DataBuffer\n");
	data_transfer_size = sizeof(DataBuffer::NetData);
	printf("SizeOf NetData %d\n",data_transfer_size );
	// TODO Auto-generated constructor stub
	thread = NULL;

	sd = NULL;
	csd = NULL;

	quit = false;
	sd = NULL;
	csd = NULL;
	connected = false;
	connectedToClient = false;
	gameType = SERVER_MODE;

	/*
	//the fancy (and non-working method)
	thread_running = false;
	arLemInData = new NetData[max_frame_store];
	arTempLemInData = new NetData[max_frame_store];
	arLemOutData = new NetData[max_frame_store];

	NetData* p = &arLemInData[0];
	NetData* p1 = &arLemOutData[0];
	NetData* p2 = &arTempLemInData[0];
	for(int n = 0; n < max_frame_store; n++){
		p->frameIndex = p1->frameIndex = p2->frameIndex = 0;
		p->index      = p1->index      = p2->index = INVALID_INDEX;
		p->new_state  = p1->new_state  = p2->new_state = INVALID_NEW_STATE;
		p++;
		p1++;
		p2++;
	}*/
}

DataBuffer::~DataBuffer() {
	// TODO Auto-generated destructor stub
	//delete(arLemInData);
	//delete(arLemOutData);
}

void DataBuffer::ResetConnection(){
	//connectedToClient = false;
	//csd = NULL;
	connected = false;
	if(gameType == CLIENT_MODE)
	{
		SDLNet_TCP_Close(sd);
	}
	else
	{
		SDLNet_TCP_Close(sd);
		SDLNet_TCP_Close(csd);
	}
}

bool DataBuffer::IsClientConnected(){
	//this is for the fancy (non working version)
	//return connectedToClient;

	if(!connectedToClient && sd != NULL && (csd = SDLNet_TCP_Accept(sd))){
		printf("(IsClientConnected) apparently we are connected to the client..\n");
		connectedToClient = true;
	}

	return connectedToClient;
}

bool DataBuffer::ConnectToServer(std::string IPAddress){
	IPaddress ip;
	gameType = CLIENT_MODE;
	if (!connected) {
		printf("(databuffer) Client trying to connect\n");
		if (SDLNet_Init() == 0) {
			/* Resolve the host we are connecting to */
			if (SDLNet_ResolveHost(&ip, IPAddress.c_str(), 2001) == 0) {
				fprintf(stderr, "(databuffer) Client Resolved host...\n");
				/* Open a connection with the IP provided (listen on the host's port) */
				if (!(sd = SDLNet_TCP_Open(&ip))) {
					fprintf(stderr, "(databuffer) SDLNet_TCP_Open: %s\n", SDLNet_GetError());
					connected = false;
				} else {
					fprintf(stderr, "(databuffer) Client connected to server...\n");
					connected = true;
				}
			}
		} else {
			printf("(databuffer) SDL_NET failed to init\n");
		}

		if(connected)
		{
			fprintf(stderr, "(databuffer) Client ready to recieve\n");
		}
	}

	return connected;
}

bool DataBuffer::ConnectToClient(){
	IPaddress ip;
	gameType = SERVER_MODE;
	if (!connected) {
		printf("(databuffer) Server trying to connect\n");
		if (SDLNet_Init() == 0) {
			printf("(databuffer) SDL_Net has inited\n");
			/* Resolving the host using NULL make network interface to listen */
			if (SDLNet_ResolveHost(&ip, NULL, 2001) == 0) {
				printf("(databuffer) Server Resolved host...\n");
				/* Open a connection with the IP provided (listen on the host's port) */
				if (!(sd = SDLNet_TCP_Open(&ip))) {
					fprintf(stderr, "(databuffer) SDLNet_TCP_Open: %s\n o", SDLNet_GetError());
					exit(EXIT_FAILURE);
				} else {
					printf("(databuffer) Server now has port open...\n");
					connected = true;
				}
			} else {
				printf("SDLNet_ResolveHost: \n");
			}
		} else {
			printf("SDLNET failed to init\n");
		}
	}

	return connected;
}

/*
 * THIS ONE WORKS. Well it should, it just sends the current move and gets back the one from the other end
 */
bool DataBuffer::RequestForData(DataBuffer::NetData *inData, DataBuffer::NetData *outData) {
    bool success = false;

    /*
    byte dataIn=0;
    byte dataOut=0;
    if (gameType == SERVER_MODE && csd != NULL) {
    	if (SDLNet_TCP_Recv(csd, dataIn, 1) == 1) {

    		if(outData.index != INVALID_INDEX) {
    			dataOut = (outData.new_state << 4) | (byte)outData.index;
    		}
    		else {
    			dataOut = (outData.new_state << 4) | (byte)81;//81 is invalid for us
    		}

		    if (SDLNet_TCP_Send(csd, (void *) inData, data_transfer_size) == data_transfer_size) {
		        success = true;
		    } else {
		        fprintf(stderr, "Server failed to send!\n");
		    }
        } else {
		 fprintf(stderr, "Server received less than it should!\n");
	    }
    } else if (gameType == CLIENT_MODE && sd != NULL) {
    	if (SDLNet_TCP_Send(sd, (void *) inData, data_transfer_size) == data_transfer_size) {
		     if (SDLNet_TCP_Recv(sd, outData, data_transfer_size) == data_transfer_size) {
		         success = true;
		     } else {
		         fprintf(stderr, "client received not enough\n");
		     }
		 } else {
		     fprintf(stderr, "Client failed to send!\n");
		 }
     }
    */

    if (gameType == SERVER_MODE && csd != NULL) {
    	if (SDLNet_TCP_Recv(csd, outData, data_transfer_size) == data_transfer_size) {
		     if (SDLNet_TCP_Send(csd, (void *) inData, data_transfer_size) == data_transfer_size) {
		         success = true;
		     } else {
		         fprintf(stderr, "Server failed to send!\n");
		     }
        } else {
		 fprintf(stderr, "Server received less than it should!\n");
	    }
    } else if (gameType == CLIENT_MODE && sd != NULL) {
    	if (SDLNet_TCP_Send(sd, (void *) inData, data_transfer_size) == data_transfer_size) {
		     if (SDLNet_TCP_Recv(sd, outData, data_transfer_size) == data_transfer_size) {
		         success = true;
		     } else {
		         fprintf(stderr, "client received not enough\n");
		     }
		 } else {
		     fprintf(stderr, "Client failed to send!\n");
		 }
     }

     return success;
 }

bool DataBuffer::CloseConnection() {
	if (sd != NULL) {
		printf("(Game) Closing connection\n");
		SDLNet_TCP_Close(sd);
		sd = NULL;
		connected = false;
	}

	if(csd != NULL){
		printf("(Game) Closing connection\n");
		SDLNet_TCP_Close(csd);
		csd = NULL;
		connected = false;
	}

	return true;
}

int DataBuffer::GetLevelFromServer() {
	char levelRequest;
	char newLevel;
	bool success = false;
	levelRequest = 1;

	if (SDLNet_TCP_Send(sd, (void *) &levelRequest, 1) == 1) {
		newLevel = 0;
		if (SDLNet_TCP_Recv(sd, &newLevel, 1) == 1) {
			success = true;
		} else {
			fprintf(stderr, "client received not enough\n");
		}
	} else {
		fprintf(stderr, "Client failed to send!\n");
	}

	if (success)
		return (int) newLevel;
	else
		return -1;
}

bool DataBuffer::SetClientLevel(int newLevel) {
	bool success = false;
	char getRequest = 0;
	if (SDLNet_TCP_Recv(csd, &getRequest, 1) == 1) {
		char newLevelData = (char) newLevel;
		if (SDLNet_TCP_Send(csd, (void *) &newLevelData, 1) == 1) {
			success = true;
		} else {
			fprintf(stderr, "Server failed to send!\n");
		}
	} else {
		fprintf(stderr, "Server received less than it should!\n");
	}

	return success;
}

/*//compressing 2 bytes into 1 byte
 bool Game::RequestForData() {
 bool success = false;
 byte dataIn=0;
 byte dataOut=0;

 if (gameType == StatusPanel::Server) {
 //
 //  SERVER RECIEVING DATA
 //
 if (SDLNet_TCP_Recv(csd, &dataIn, 1) == 1) {

 if(lemOutData.index != INVALID_INDEX) {
 dataOut = (lemOutData.new_state << 4) | (byte)lemOutData.index;
 }
 else {
 dataOut = (lemOutData.new_state << 4) | (byte)81;//81 is invalid for us
 }
 //
 // SERVER SENDING DATA
 //
 if (SDLNet_TCP_Send(csd, (void *) &dataOut, 1) == 1) {
 success = true;
 lemInData.index = (dataIn & 0xF)+80;
 lemInData.new_state = (dataIn & 0xF0) >> 4;

 if(lemInData.index == 81)
 lemInData.index = INVALID_INDEX;


 } else {
 fprintf(stderr, "Server failed to send!\n");
 }
 } else {
 fprintf(stderr, "Server received less than it should!\n");
 }

 } else if (gameType == StatusPanel::Client) {
 if(lemOutData.index != INVALID_INDEX){
 dataOut = (lemOutData.new_state << 4) | (byte)(lemOutData.index-80);
 }
 else
 {
 dataOut = (lemOutData.new_state << 4) | (byte)(81);
 }

 if (SDLNet_TCP_Send(sd, (void *) &dataOut, 1) == 1) {
 if (SDLNet_TCP_Recv(sd, &dataIn, 1) == 1) {
 success = true;
 lemInData.index = (dataIn & 0xF);
 lemInData.new_state = (dataIn & 0xF0) >> 4;

 if(lemInData.index == 81)
 lemInData.index = INVALID_INDEX;

 } else {
 fprintf(stderr, "client received not enough\n");
 }
 } else {
 fprintf(stderr, "Client failed to send!\n");
 }
 } else if (gameType == StatusPanel::SinglePlayer)
 success = true;

 return success;
 }*/

/*
 * ************** EVerything beyong here is test code that is currently unused ********
 *
 *
 */

/*
 * This is fancy (non-working) method
 */
/*
bool DataBuffer::RequestForData(DataBuffer::NetData* currentChange) {
	bool retVal = false;

	DataBuffer::NetData* change1 = NULL;
	(void) StoreLocalChange(&change1, currentChange);

	if (change1 != NULL) {
		printf("(RequestForData) change1 is not null\n");
		AddData(change1->index, change1->new_state, change1->frameIndex);
	}
	DataBuffer::NetData* arLemInData = GetData();

	//right, let's do something with the data then
	//first, do we need to do anything?
	if (IsReanimationRequired(&arLemInData[0], currentChange) || change1 != NULL) {
		printf("re-animating is required\n");
		DataBuffer::NetData* p = &arLemInData[0];
		//First, see if we have any new changes to add:
		for (int n = 0; n < DataBuffer::max_frame_store; n++) {
			if (p->frameIndex != 0) {
				DataBuffer::NetData newData;
				newData.frameIndex = p->frameIndex;
				newData.new_state = p->new_state;
				newData.index = p->index;

				arAllGameChanges.push_back(newData);

				//now reset it:
				p->frameIndex = 0;
				p->new_state = INVALID_NEW_STATE;
				p->index = INVALID_INDEX;
			}
			p++;
		}

		retVal = true;
	}

	return retVal;
}*/

/*
void DataBuffer::StartThread(){
	//Create and run the thread
	// Create the synchronization lock
	printf("starting thread\n");
	datalock = SDL_CreateMutex();
	connectedToClient = false;
	thread_running = true;
	thread = SDL_CreateThread( my_thread, datalock );
}

bool DataBuffer::EndThread(){
	printf("trying to stop thread!\n");
	quit = true;
	while(thread_running){
		SDL_Delay(1000);
	}

	printf("Stopped thread!\n");
	return true;
}

void DataBuffer::LockData(){
	SDL_mutexP(datalock);
}

void DataBuffer::UnlockData(){
	SDL_mutexV(datalock);
}

DataBuffer::NetData* DataBuffer::GetData(){
	NetData* pData =  &arLemInData[0];
	for(int n = 0; n < max_frame_store; n++){
		if(pData->frameIndex != 0){
			printf("getting fIndex %d, index %d, state %d\n", pData->frameIndex, pData->index, pData->new_state);
		}
		pData++;
	}
	return &arLemInData[0];
}


void DataBuffer::AddData(unsigned char index, unsigned char state, unsigned int findex){
	//lock the buffer
	//SDL_mutexP(datalock);
	//add the data
	//find a free slot in the array
	NetData* pData =  &arLemOutData[0];
	for(int n = 0; n < max_frame_store; n++){
		if(pData->frameIndex == 0){
			printf("adding fIndex %d, index %d, state %d\n", findex, index, state);
			//this ones is free, use it!
			pData->frameIndex = findex;
			pData->index = index;
			pData->new_state = state;
			break;
		}

		pData++;
	}
	//unlock the buffer
	//SDL_mutexV(datalock);
}

int DataBuffer::my_thread( void *data ) {
	SDL_mutex *lock = (SDL_mutex *)data;
	quit = false;
	const int dSize = data_transfer_size*max_frame_store;
	//While the program is not over
	while( quit == false ) {
	    SDL_mutexP(lock);
	    SDL_Delay(2);

		switch(gameType){
			case(SERVER_MODE):
				if(!connectedToClient){
			    	if( (csd = SDLNet_TCP_Accept(sd))){
			    		printf("apparently we are connected to the client..\n");
			    		connectedToClient = true;
			    	}
			    }else{
			    	if(csd != NULL){
						if (SDLNet_TCP_Recv(csd, arTempLemInData, dSize) == dSize) {

							StoreRecievedData();

							if (SDLNet_TCP_Send(csd, (void *) arLemOutData, dSize) == dSize) {
								//once it's sent, fuck it off:
								ClearOutData();
							}else{
								fprintf(stderr, "Server failed to send!\n");
								quit = true;
							}

						} else {
							quit = true;
							//fprintf(stderr, "Server received less than it should!\n");
						}
			    	}
			    }
			break;

			case(CLIENT_MODE):
				if(sd != NULL){
					if (SDLNet_TCP_Send(sd, (void *) arLemOutData, dSize) == dSize) {
						//once it's sent, fuck it off:
						ClearOutData();

						if (SDLNet_TCP_Recv(sd, arTempLemInData, dSize) == dSize) {
							StoreRecievedData();
						}
						else{
							fprintf(stderr, "client received not enough\n");
							quit = true;
						}

					} else {
						//fprintf(stderr, "Client failed to send!\n");
					}
				}
			break;
		}
	    SDL_mutexV(lock);
	}
	thread_running = false;
	return 0;
}

void DataBuffer::StoreRecievedData(){
	NetData* pData =  &arTempLemInData[0];
	for(int n = 0; n < max_frame_store; n++){
		if(pData->frameIndex != 0){
			//printf("Recvd fIndex %d, index %d, state %d\n", pData->frameIndex, pData->index, pData->new_state);
			//so pop it onto the list
			for(int n = 0; n < max_frame_store; n++){
				if(arTempLemInData[n].frameIndex != 0){
					NetData* p2 =  &arLemInData[0];
					for(int n = 0; n < max_frame_store; n++){
						if(p2->frameIndex == 0){
							//this ones is free, use it!
							p2->frameIndex  = pData->frameIndex;
							p2->index 		= pData->index;
							p2->new_state   = pData->new_state;
							break;
						}

						p2++;
					}
				}
			}
		}
		pData++;
	}
}

void DataBuffer::ClearOutData(){
	for(int n = 0; n < max_frame_store; n++){
		arLemOutData[n].frameIndex = 0;
		arLemOutData[n].index = 255;
		arLemOutData[n].new_state = 255;
	}
}

//
// Checks in/out data to see if re-animation is required
//
bool DataBuffer::IsReanimationRequired(DataBuffer::NetData* IncomingData, DataBuffer::NetData* gameChange) {
	bool itisimafraid = false;

	//loop through all 'in' Data
	DataBuffer::NetData* p = &IncomingData[0];
	//p1 = &arMyGameChanges[0];
	for (int n = 0; n < DataBuffer::max_frame_store; n++) {
		if ((p->frameIndex != 0))
		{
			itisimafraid = true;
		}
		p++;
	}

	if (gameChange->frameIndex != 0)
	{
		itisimafraid = true;
	}

	return itisimafraid;
}

bool DataBuffer::StoreLocalChange(DataBuffer::NetData** change1, DataBuffer::NetData* currentGameChange) {
	if (currentGameChange->frameIndex != 0) {
		DataBuffer::NetData newData;
		newData.frameIndex = currentGameChange->frameIndex;
		newData.new_state = currentGameChange->new_state;
		newData.index = currentGameChange->index;
		printf("(game) adding frameIndex: %d\n", currentGameChange->frameIndex);

		//store in big old array:
		push_back(&newData);

		//send to network bufferer:
		//clear out the change so it doesn't happen again...
		currentGameChange->frameIndex = 0;
		currentGameChange->index = INVALID_INDEX;
		currentGameChange->new_state = INVALID_NEW_STATE;

		printf("storing change\n");

		//set pointer to our copy
		*change1 = at(size() - 1);
		return true;
	}
	return false;//multiple return points...yeah
}

void DataBuffer::push_back(DataBuffer::NetData* lemData){
	arAllGameChanges.push_back(*lemData);
}

DataBuffer::NetData* DataBuffer::at(int index){
	return &arAllGameChanges.at(index);
}

int DataBuffer::size(){
	return 	arAllGameChanges.size();
}*/
