/*
 * DataBuffer.h
 *
 *  Created on: 1 Mar 2010
 *      Author: mat
 */

#ifndef DATABUFFER_H_
#define DATABUFFER_H_
#include "SDL/SDL_thread.h"
#include <vector>
#include "SDL/SDL_net.h"
#include <string>

#define INVALID_INDEX 255
#define INVALID_NEW_STATE 255

class DataBuffer {
public:
	DataBuffer();
	virtual ~DataBuffer();

	//TODO: should be able to reduce this even further
	//as max single player lem is actually 80 (I.E. less than
	//256/2=128. So we should be able to use the
	//top 4 bits for 0-80 and the bottom 4 for state
	struct NetData
	{
		//unsigned int frameIndex;//0-65535, max 43 minutes per game...
		unsigned char new_state;//0-8
		unsigned char index;//0-160 (should be 0-80!!!!)
	};

	/*
	//the fancy (and non-wokring method)
	void StartThread();
	bool EndThread();
	void LockData();
	void UnlockData();
	bool RequestForData(DataBuffer::NetData* currentChange);
	bool StoreLocalChange(DataBuffer::NetData** change1, DataBuffer::NetData* currentGameChange);
	static int max_frame_store;//max frame to store!
	void push_back(DataBuffer::NetData*);
	DataBuffer::NetData* at(int);
	int size();
	*/

	void AddData(unsigned char index, unsigned char state, unsigned int findex);
	NetData* GetData();

	bool ConnectToServer(std::string);
	bool ConnectToClient();
	bool CloseConnection();
	void ResetConnection();
	bool IsClientConnected();
	bool IsReanimationRequired(DataBuffer::NetData* IncomingData, DataBuffer::NetData* gameChange);
	bool RequestForData(DataBuffer::NetData *lemInData, DataBuffer::NetData *lemOutData);
	int GetLevelFromServer();
	bool SetClientLevel(int newLevel);

private:
	SDL_Thread *thread;
	static int my_thread( void *data );

	TCPsocket sd, csd; // Socket descriptor, Client socket descriptor
	bool quit;
	int fcount;
	int gameType;
	bool connected;
	bool connectedToClient;
	int data_transfer_size;

	//bool thread_running;
	//static NetData* arLemInData;//array of n frame changes
	//static NetData* arTempLemInData;//array of n frame changes
	//static NetData* arLemOutData;//array of n frame changes
	//static SDL_mutex *datalock;

	//static void StoreRecievedData();
	//static void ClearOutData();

	//std::vector<DataBuffer::NetData> arAllGameChanges;
};


#endif /* DATABUFFER_H_ */
